#include <stdio.h>
// #include <stdint.h>
#include <inttypes.h>

// My code
#include "math_functions.h"
#include "hello.h"
#include "struct_test.h"
#include "pointer_test.h"
#include "read_file.h"

#include "mysql_test.h"

// Test
// https://stackoverflow.com/questions/8666378/detect-windows-or-linux-in-c-c
#ifdef _WIN32
#include <Windows.h>
#endif

#include "stdbool.h"

// To setup this project on windows
// 1. Install CMake
// 2. Install Ninja with winget in windows 11: "winget install --id=Ninja-build.Ninja -e"
// 3. Make a build directory in this project and cd into it
// 4. Run this CMake command: "cmake -GNinja .."
// 5. Change into Debug/Release folder
// 6. Run this command to build: "cmake --build .. --config Debug"

// https://phoenixnap.com/kb/install-gcc-windows
// https://stackoverflow.com/questions/36770716/mingw64-make-build-error-bash-make-command-not-found
// To build without installing Visual Studio:
// 1. Download MingW64 from here: https://winlibs.com/#download-release
// 2. Place the folder into C:\
// 3. Add this folder to the path: "C:\mingw64\bin"
// 4. Download Make without guile from here: https://sourceforge.net/projects/ezwinports/files/
// 5. Copy files from make into "C:\mingw64", do not replace existing files!
// 6. Create a build folder and cd into it
// 7. Run this CMake command to generate build files: "cmake -G "MinGW Makefiles" .."
// 8. To build Run "make"

// I switched to msys2 and used this guide for the toolkit:
// https://www.devdungeon.com/content/install-gcc-compiler-windows-msys2-cc

// Installed mysql in mingw64 using msys2:
// pacman -S mingw-w64-x86_64-libmariadbclient

// TODO Look into getting current directory in Windows and Linux
// https://stackoverflow.com/questions/27585930/get-the-current-working-directory-in-c-on-windows

// This might be useful for all the preprocessors for each operating system:
// https://stackoverflow.com/questions/5919996/how-to-detect-reliably-mac-os-x-ios-linux-windows-in-c-preprocessor


// TODO Move this into a different project.
#ifdef _WIN32

void guiTest()
{
    // WIN32_
}

#endif //_WIN32

#ifdef __linux__
// TODO Test this
#include <pwd.h>
#endif //__linux__

// #define _FLIP_BOOLS
// Hmm, very evil
#ifdef _FLIP_BOOLS
// This is just madness, inverting the boolean values :P
#define true FALSE
#define false TRUE
// #define true (rand() % 2)
// #define false (rand() % 2)
#endif //_FLIP_BOOLS

// https://www.reddit.com/r/C_Programming/comments/jjdl7s/difference_between_char_and_char/
// char welcomeMsg[] = "Welcome to KCNet";
const char *kcnetMsg = "[KCNet]:";
const char *welcomeMsg = "Welcome to KCNet";
const char *errorMsg = "Error:";

void flip_bools()
{
#ifdef _FLIP_BOOLS
    bool testb = false;
    if (testb)
    {
        printf("True");
    }
    else
    {
        printf("False");
    }
#else
    // Print the message that this isn't enabled
    printf("%s %s This is not enabled!\n", kcnetMsg, errorMsg);
#endif //_FLIP_BOOLS
}

// TODO Look into making a gtk C program
// https://www.geeksforgeeks.org/how-to-create-gui-in-c-programming-using-gtk-toolkit/

// Print out the memory addresses for each item in an array.
void array_test()
{
    // https://www.tutorialspoint.com/cprogramming/c_memory_address.htm
    // Int array
    int numbers[5] = {1, 2, 3, 4, 5};
    int i = 0;

    printf("numbers = %p\n", numbers);

    do
    {
        printf("numbers[%u] = %p\n", i, (void *)&numbers[i]);
        i++;
    } while (i < 5);

    printf("sizeof(numbers) = %lu\n", sizeof(numbers));
}

// Removed from path in windows: C:\mingw64\bin

// https://www.tutorialspoint.com/cprogramming/c_ternary_operator.htm
void check_even_odd(int num)
{
    (num % 2 == 0) ? printf("%d is even\n", num) : printf("%d is odd\n", num);

    // return;
}

void user_input()
{
    int value;           // Value for the switch loop
    int number_to_check; // Number to check for even/odd check in the loop

    // Pointer test
    int i = 22222;   // Random value
    int *i_ptr = &i; // Pointer to that random value
    //

    while (true)
    {
        // for (;;){

        // Oops this was outside of the loop and breaking it...
        // Well I fixed that part of it.
        printf("\n%s What would you like to do? "
               "1 (Array Test), "
               "2 (Check Even or Odd), "
               "3 (Print welcome msg), "
               "4 (Flip bools {if enabled}), "
               "5 (Read file), "
               "6 (Print struct), "
               "7 (Math test), "
               "8 (Pointer test), "
               "9 (Get User Profile): ",
               kcnetMsg);
        scanf("%d", &value);

        switch (value)
        {
        case 1:
            array_test();
            break;
        case 2:
            printf("Enter a number to check: ");
            scanf("%d", &number_to_check);
            check_even_odd(number_to_check);
            break;
        case 3:
            printf("%s\n", welcomeMsg);
            break;
        case 4:
            flip_bools();
            break;
        case 5:
            read_file("test.txt");
            break;

        case 6:
            print_struct();
            break;
        case 7:
            // printf("Test #7");
            mathFunctions();
            break;
        case 8:
            // printf("Test #8");
            pointer_madness(i_ptr);
            break;

        case 9:
            // printf("Test #8");
            #ifdef _WIN32
            printf("%s User profile path: %s\n", kcnetMsg, getenv("USERPROFILE"));
            #endif // _WIN32
            #ifdef __linux__
            // https://stackoverflow.com/questions/1451825/c-programming-printing-current-user
            // https://stackoverflow.com/questions/41976889/c-user-name-in-linux-get-current-user-name
            // TODO Fix this
            struct passwd *p = getpwuid(getuid());
            if (p != NULL) 
            {
                printf("%s %s\n", kcnetMsg, p->pw_name);
            }
            else
            {
                printf("%s The user seems to be invalid.", errorMsg)
            }


            #endif //__linux__
            break;

        default:
            printf("Invalid option %d", &value);
            break;
        }
    }
    // printf("Enter a number: ");
    // scanf("%d", &my_num);
    // printf("You entered the number: \"%d\"", my_num);
}

int main()
{

    // printf("%s\n", welcomeMsg);

    // uint16_t test = -2;

    user_input();
    // TODO Fix this to work.
    // connect_mysql();

    // array_test();
    // for (int i=0; i<5; i++) {
    //     check_even_odd(i);
    // }
    // check_even_odd(1);

    // print_struct();
    // read_file("test.txt");

    // This doesn't work
    // uint16_test();

    //? 65534? Where is that number coming from
    // https://stackoverflow.com/questions/29112878/how-do-i-printf-a-uint16-t
    // printf("Number: %u", (unsigned int)test);

    // https://stackoverflow.com/questions/12120426/how-do-i-print-uint32-t-and-uint16-t-variables-value
    // printf("Number: %" PRIu32, test);

    // printf_example();
    return 0;
}